"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ShardingModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShardingModule = void 0;
const common_1 = require("@nestjs/common");
const sharding_manager_1 = require("../sharding-manager");
const repository_service_1 = require("../repository-service/repository-service");
const MetadataUtils_1 = require("typeorm/metadata-builder/MetadataUtils");
const __1 = require("..");
let ShardingModule = ShardingModule_1 = class ShardingModule {
    static forRoot(options) {
        return {
            module: ShardingModule_1,
            providers: [
                {
                    provide: 'SHARDING_OPTIONS',
                    useValue: options
                },
                {
                    provide: sharding_manager_1.ShardingManager,
                    useFactory: (opts) => {
                        return sharding_manager_1.ShardingManager.createInstance(opts);
                    },
                    inject: ['SHARDING_OPTIONS']
                },
                repository_service_1.RepositoryService
            ],
            exports: [sharding_manager_1.ShardingManager, repository_service_1.RepositoryService]
        };
    }
    static forFeature(entities) {
        const providers = entities.map(entity => {
            const isSharded = MetadataUtils_1.MetadataUtils.getInheritanceTree(entity).includes(__1.ShardingBaseEntity);
            const repositoryToken = isSharded
                ? `ShardingRepositoryService<${entity.name}>`
                : `TypeormRepositoryService<${entity.name}>`;
            return {
                provide: repositoryToken,
                useFactory: () => repository_service_1.RepositoryService.of(entity),
            };
        });
        return {
            module: ShardingModule_1,
            providers,
            exports: providers,
        };
    }
};
ShardingModule = ShardingModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], ShardingModule);
exports.ShardingModule = ShardingModule;
