"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeormRepositoryService = void 0;
class TypeormRepositoryService {
    constructor(entityType) {
        this.entityType = entityType;
    }
    create(entityLike) {
        return this.entityType.create(entityLike);
    }
    save(entities, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.save(entities, options);
        });
    }
    remove(entities, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.remove(entities, options);
        });
    }
    softRemove(entities, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.softRemove(entities, options);
        });
    }
    update(criteria, partialEntity) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.update(criteria, partialEntity);
        });
    }
    delete(criteria) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.delete(criteria);
        });
    }
    count(options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.count(options);
        });
    }
    countBy(where) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.countBy(where);
        });
    }
    find(options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.find(options);
        });
    }
    findBy(where) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findBy(where);
        });
    }
    findAndCount(options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findAndCount(options);
        });
    }
    findAndCountBy(where) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findAndCountBy(where);
        });
    }
    findByIds(ids, shardingKey) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findByIds(ids, shardingKey);
        });
    }
    findOneById(id, shardingKey) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findOneById(id, shardingKey);
        });
    }
    findOne(options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findOne(options);
        });
    }
    findOneBy(where) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.entityType.findOneBy(where);
        });
    }
}
exports.TypeormRepositoryService = TypeormRepositoryService;
