"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShardingEntity = void 0;
const typeorm_1 = require("typeorm");
const typeorm_sharding_type_1 = require("./types/typeorm-sharding.type");
function ShardingEntity(options) {
    return (target) => {
        let entityOptions;
        if (options.type === typeorm_sharding_type_1.ShardingType.RANGE) {
            const { type, findShard, findShardById } = options, opt = __rest(options, ["type", "findShard", "findShardById"]);
            entityOptions = opt;
            Reflect.defineMetadata('SHARDING_TYPE', type, target);
            Reflect.defineMetadata('SHARDING_FUNC', findShard, target);
            Reflect.defineMetadata('SHARDING_FUNC_BY_ID', findShardById, target);
            /*
        } else if (options.type === ShardingType.MODULAR) {
            const { type, findShard, keyProvider, ...opt } = options;
            entityOptions = opt;
            Reflect.defineMetadata('SHARDING_TYPE', type, target);
            Reflect.defineMetadata('SHARDING_FUNC', findShard, target);
            Reflect.defineMetadata('SHARDING_KEY_PROVIDER', keyProvider, target);
             */
        }
        else if (options.type === typeorm_sharding_type_1.ShardingType.LIST) {
            const { type, findShard } = options, opt = __rest(options, ["type", "findShard"]);
            entityOptions = opt;
            Reflect.defineMetadata('SHARDING_TYPE', type, target);
            Reflect.defineMetadata('SHARDING_FUNC', findShard, target);
        }
        else
            throw new Error('ShardingEntity: Unsupported sharding type');
        (0, typeorm_1.Entity)(entityOptions)(target);
    };
}
exports.ShardingEntity = ShardingEntity;
